<isol>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#include <directfb.h>

static IDirectFB             *dfb;
static IDirectFBDisplayLayer *layer;
static IDirectFBWindow       *window;
static IDirectFBSurface      *window_surface;

int main (int argc, char **argv) {
  int quit = 0;

  DFBWindowDescription    wdsc;
  IDirectFBImageProvider *provider;

  /* Super-Interface holen. */
  DirectFBCreate (&argc, &argv, &dfb);

  /* Interface auf den Primary-Layer holen, 
     um dort ein Fenster zu erstellen. */
  dfb->GetDisplayLayer (dfb, DLID_PRIMARY, &layer);

  /* Wie bei einem Surface wird vorher 
     eine Window Description ausgefllt. */
  wdsc.flags = DWDESC_WIDTH | DWDESC_HEIGHT;
  wdsc.width = 300;
  wdsc.height = 100;

  /* Nun wird das Fenster erstellt, 
     es ist jedoch noch nicht sichtbar. */
  layer->CreateWindow (layer, &wdsc, &window);

  /* Um etwas darzustellen, Interface auf
     das Surface des Fensters besorgen. */
  window->GetSurface (window, &window_surface);

  /* Opacity auf 100% setzen
     , nun ist das Fenster sichtbar. */
  window->SetOpacity (window, 0xff);

  while (!quit) {
    DFBWindowEvent event;

    /* Auf Event warten */
    window->WaitForEvent (window);

    /* Events verwarbeiten. */
    while (window->GetEvent (window, &event) == DFB_OK) {
      switch (event.type) {
	/* Wurde die Maus in das Fenster bewegt, 
	   wei fllen . */
	case DWET_ENTER:
	  window_surface->SetColor (window_surface, 0xff, 0xff, 0xff, 0xff);
	  window_surface->FillRectangle (window_surface, 0, 0, 
					 wdsc.width, wdsc.height);
	  window_surface->Flip (window_surface, NULL, 0);
	  break;

	  /* Hat die Maus das Fenster verlassen, 
	     schwarz fllen . */
	case DWET_LEAVE:
	  window_surface->SetColor (window_surface, 0, 0, 0, 0xff);
	  window_surface->FillRectangle (window_surface, 0, 0, 
					 wdsc.width, wdsc.height);
	  window_surface->Flip (window_surface, NULL, 0);
	  break;

	  /* Wurde auf das Fenster geklickt, 
	     Programm beenden. */
	case DWET_BUTTONDOWN:
	  quit = 1;
	  break;
      }
    }
  }


  /* Stack artig werden die Interfaces wieder freigegeben. */
  window_surface->Release (window_surface);
  window->Release (window);
  layer->Release (layer);
  dfb->Release (dfb);
  
  return 23;
}

