Attribute VB_Name = "modADOEX2K"
' ===========================================================
' Beispiele zur Exchange 2000-Programmierung
' (C) Holger Schwichtenberg 2001 (hs@windows-scripting.de)
' ===========================================================
' Diese Beispiele werden in der 3.Auflage des Buchs
' "Windows- und Backoffice-Scripting"
' im Juli 2001 bei Addison-Wesley erscheinen!
' ===========================================================
' Daten der ersten und zweiten Auflage:
' Verlag: Addison-Wesley
' ISBN: 3-8273-1637-5; Preis: 99,90 DM
' Autor: Holger Schwichtenberg, (C) 2000
' ===========================================================
' Weitere Informationen unter http://www.windows-scripting.de
' Aktualisierungen und Bugfixes  werden dort verffentlicht!
' ===========================================================


Option Explicit

' ### Verbindungsaufbau
Function ADOEX2K_Connect(rooturl)
Dim objCon ' As ADODB.Connection
say "Verbindung zu: " & rooturl
Set objCon = CreateObject("ADODB.Connection")
objCon.Provider = "MSDAIPP.DSO"
' Auf dem Server alternativ:
' objCon.Provider = "ExOLEDB.DataSource"
objCon.ConnectionString = rooturl
objCon.Open
Set ADOEX2K_Connect = objCon
End Function

' ### Liefert einen Zeiger auf eine einzelnes Objekt
Function get_ExRec(url)
Dim rec ' As ADODB.Record
say "ffnen des Ordners: " & url
' --- Instanzzierung der Klasse
Set rec = CreateObject("ADODB.Record")
' --- ffnen des Record zum Lesen und Schreiben
Const adModeReadWrite = 3
rec.Open url, , adModeReadWrite
say "Ordner geffnet: " & rec.ActiveConnection
Set get_ExRec = rec
End Function

' ### Liefert einen Zeiger auf eine eine Objektmenge
Function get_ExRS(url, Query)
Dim rs ' As ADODB.Recordset
Dim objRec ' As ADODB.Record
' --- Instanzzierung der Klasse
Set rs = CreateObject("ADODB.Recordset")
' --- Erst Ordner ffnen
Set objRec = get_ExRec(url)
' --- Mit dieser Verbindung Query ausfhren
rs.Open Query, objRec.ActiveConnection
Set get_ExRS = rs
End Function

' ### Hilfsroutine: Universelle Tabellenausgabe
Sub list_table(rs)
Dim a ' Ausgabe
Dim f ' as ADODB.Field
' --- Ausgabe der Feldnamen
a = ""
For Each f In rs.fields
    ' --- Zusammensetzen der Ausgabe
    If a <> "" Then a = a & ";"
    a = a & f.Name
Next
say a
' --- Iteration ber alle Datenstze
Do While Not rs.EOF
    a = ""
    ' --- Iteration ber alle Felder
    For Each f In rs.fields
        ' --- Zusammensetzen der Ausgabe
        If a <> "" Then a = a & ";"
        If Not IsNull(rs(f.Name)) Then
                a = a & CStr(rs(f.Name))
        End If
    Next
' --- Ausgabe
say a
' --- nchster Datensatz
rs.MoveNext
Loop
End Sub

' ### Ausgabe aller Felder eines (Record-)Objekts
Sub list_fields(obj)
Dim oF ' As ADODB.Field
say "Anzahl der Eigenschaften: " & obj.fields.Count
For Each oF In obj.fields
   If IsNull(oF.Value) Then
      say oF.Name & "= NULL"
   Else
      say oF.Name & "=" & flat(oF.Value)
   End If
Next
End Sub



' === Beispiel fr den Zugriff auf einen Ordner
Sub ADOEX2K_OrdnerAttributeLesen()
Dim rec ' As ADODB.Record
Dim url ' As String
' --- Verbindungsaufbau
' Angaben zum Ordner
Const DOMAIN = "sonne2000.IT-Visions.de"
Const WURZEL = "public"
Const ORDNER = "Lehre/Wintersemester2001_2002/VTBDV1"
' URL zusammenbauen
url = "http://" & DOMAIN & "/" & WURZEL & "/" & ORDNER
say "Zugriff auf Ordner: " & url
' Instanzzierung der Klasse
Set rec = CreateObject("ADODB.Record")
' ffnen des Record zum Lesen und Schreiben
Const adModeReadWrite = 3
rec.Open url, , adModeReadWrite
say "Ordner geffnet!"
' --- Zugriff auf einzelne Attribute des Ordners
say "Ordnername: " & rec.fields("DAV:Displayname")
say "URL des Ordners: " & rec.fields("DAV:href")
say "Klasse: " & rec.fields("DAV:contentclass")
say "bergeordneter Ordner: " & rec.fields("DAV:parentname")
say "Kommentar: " & rec.fields("DAV:Comment")
say "Ordnergre: " & rec.fields("http://schemas.microsoft.com/exchange/foldersize")
' --- Alternativ: Alle Attribute ausgeben via ADO-Hilfsroutine
list_fields rec
End Sub

' === Beispiel fr den Zugriff auf einen Ordner unter Verwendung einer Connection
Sub ADOEX2K_OrdnerAttributeLesen2()
Dim rec ' As ADODB.Record
Dim con ' As ADODB.Connection
Dim url ' As String
' --- Verbindungsaufbau
' Angaben zum Ordner
Const DOMAIN = "sonne2000.IT-Visions.de"
Const WURZEL = "public"
Const ORDNER = "Lehre/Wintersemester2001_2002/VTBDV1"
' URL zusammenbauen
url = "http://" & DOMAIN & "/" & WURZEL & "/" & ORDNER
say "Zugriff auf Ordner: " & url
' Instanzzierung der Klassen
Set con = CreateObject("ADODB.Connection")
Set rec = CreateObject("ADODB.Record")
' Verbindung aufbauen
con.Provider = "MSDAIPP.DSO"
con.ConnectionString = url
con.Open
' Record auf dieser Connection ffnen
Const adModeReadWrite = 3
rec.Open url, con, adModeReadWrite
say "Ordner geffnet!"

' --- Zugriff auf einzelne Attribute des Ordners
say "Ordnername: " & rec.fields("DAV:Displayname")
say "URL des Ordners: " & rec.fields("DAV:href")
say "Klasse: " & rec.fields("DAV:contentclass")
say "bergeordneter Ordner: " & rec.fields("DAV:parentname")
say "Kommentar: " & rec.fields("DAV:Comment")
say "Ordnergre: " & rec.fields("http://schemas.microsoft.com/exchange/foldersize")
' --- Alternativ: Alle Attribute ausgeben via ADO-Hilfsroutine
list_fields rec
End Sub

' === Fehler-Beispiel: Anfgen eines Attributs
Sub ADOEX2K_Ordner_NeuesAttribut()
Dim rec ' As ADODB.Record
Dim url ' As String

' --- Verbindungsaufbau
' Angaben zum Ordner
Const DOMAIN = "sonne2000.IT-Visions.de"
Const WURZEL = "public"
Const ORDNER = "Lehre/Wintersemester2001_2002/VTBDV1"
' URL zusammenbauen
url = "http://" & DOMAIN & "/" & WURZEL & "/" & ORDNER
say "Zugriff auf Ordner: " & url
' Instanzzierung der Klasse
Set rec = CreateObject("ADODB.Record")
' ffnen des Record zum Lesen und Schreiben
Const adModeReadWrite = 3
rec.Open url, , adModeReadWrite
say "Ordner geffnet: " & rec.ActiveConnection

' --- Attribut anfgen
rec.fields.Append "Name des Erstellers", adBSTR, 100, adFldFixed, "Babsi"
rec.fields.Update ' DAS GEHT NICHT !!!!!!!
' --- Alle Attribute ausgeben via ADO-Hilfsroutine
list_fields rec
End Sub

' ### Ordnerattribute ndern (ndern des Kommentars zu einem Ordner)
Sub ADOEX2()
K_Ordner_AttributAenderungen()
Dim rec ' As ADODB.Record
Dim url ' As String

' --- Verbindungsaufbau
' Angaben zum Ordner
Const DOMAIN = "sonne2000.IT-Visions.de"
Const WURZEL = "public"
Const ORDNER = "Lehre/Wintersemester2001_2002/VTBDV1"
' URL zusammenbauen
url = "http://" & DOMAIN & "/" & WURZEL & "/" & ORDNER
say "Zugriff auf Ordner: " & url
' Instanzzierung der Klasse
Set rec = CreateObject("ADODB.Record")
' ffnen des Record zum Lesen und Schreiben
Const adModeReadWrite = 3
rec.Open url, , adModeReadWrite
say "Ordner geffnet: " & rec.ActiveConnection

' --- Attribut ndern
' Zugriff Auf Attribut
Dim f ' As ADODB.Field
Set f = rec.fields("DAV:comment")
' Wert vorher
say "Alter Kommentar: " & f.Value
' Wert ndern
f.Value = "TEST " & Now
rec.fields.Update
' Wert nacher
say "Neuer Kommentar: " & f.Value
End Sub


' ### Kopieren, Verschieben und Lschen eines ffentlichen Ordners
Sub ADOEX2K_OrdnerBewegen()
Dim rec  ' As ADODB.Record
Dim url ' As String
Dim root, urlquelle, urlziel1, urlziel2

' --- Verbindungsaufbau
' Angaben zum Ordner
Const DOMAIN = "sonne2000.IT-Visions.de"
Const WURZEL = "public"
Const QUELLORDNER = "Lehre/Wintersemester2001_2002/VTBDV1"
Const ZIELORDNER1 = "Lehre/Wintersemester2001_2002/VTBDV1-archiv bis 1.8.2001"
Const ZIELORDNER2 = "Archiv/VBTDV1"

' URL zusammenbauen
root = "http://" & DOMAIN & "/" & WURZEL & "/"
urlquelle = root & QUELLORDNER
urlziel1 = root & ZIELORDNER1
urlziel2 = root & ZIELORDNER2

' Instanzzierung der Klasse
Set rec = CreateObject("ADODB.Record")
' ffnen des Record zum Lesen und Schreiben
Const adModeReadWrite = 3
rec.Open urlquelle, , adModeReadWrite
say "Ordner geffnet: " & urlquelle

' --- Kopiervorgang
rec.CopyRecord , urlziel1
say "Ordner kopiert nach " & urlziel1

' --- Verschiebevorgang
rec.MoveRecord urlziel1, urlziel2
say "Ordner verschoben nach " & urlziel2

' --- Ordner lschen
rec.DeleteRecord urlziel2
say "Ordner gelscht: " & urlziel2
End Sub

' === Anlegen eines neuen Ordner
Sub ADOEX2K_OrdnerAnlegen()
Dim rec ' as ADODB.Record
Dim url ' As String

' --- Verbindungsaufbau
' Angaben zum Ordner
Const DOMAIN = "sonne2000.IT-Visions.de"
Const WURZEL = "public"
Const ORDNER = "Lehre/Wintersemester2001_2002/Studenten/x"
' URL zusammenbauen
url = "http://" & DOMAIN & "/" & WURZEL & "/" & ORDNER

' Instanzzierung der Klasse
Set rec = CreateObject("ADODB.Record")

' --- Ordner erzeugen
Const FOLDERTYP = "IPF.Contact"
Const adModeReadWrite = 3
Const adCreateCollection = 8192
rec.Open url, , adModeReadWrite, adCreateCollection

' --- Attribute festlegen
rec.fields("DAV:contentclass") = _
"urn:content-classes:folder"
rec.fields("http://schemas.microsoft.com/exchange/outlookfolderclass") = FOLDERTYP

' --- Speichern
rec.fields.Update
rec.Close
say "Ordner angelegt: " & url

End Sub

' === Inhalts eines Ordners auflisten
Sub ADOEX2K_Ordnerinhalt()
Dim rs ' As ADODB.Recordset
Dim Query ' As String
Dim url ' As string
' --- Angaben zum Ordner
Const DOMAIN = "sonne2000.IT-Visions.de"
Const WURZEL = "public"
Const ORDNER = "Lehre/Wintersemester2001_2002/VTBDV1"
' --- URL zusammenbauen
url = "http://" & DOMAIN & "/" & WURZEL & "/" & ORDNER
say "Zugriff auf Ordner: " & url
' --- QueryString
Query = "select ""urn:schemas:mailheader:content-class"" "
Query = Query & ",""DAV:href"",""DAV:displayname"" "
Query = Query & " from scope ('shallow traversal of "
Query = Query & Chr(34) & url & Chr(34) & "')"
Query = Query & " ORDER BY ""DAV:displayname"" "
say "Abfrage: " & Query
' --- Menge anfordern
Set rs = get_ExRS(url, Query)
' --- Ausgabe des Inhalts
list_table rs
End Sub

' === Alle Nachrichten aus einem Ordner lschen
Sub ADOEX2K_Ordnerinhaltloeschen()
Dim rs ' As ADODB.Recordset
Dim Query ' As String
Dim url ' As string
' --- Angaben zum Ordner
Const DOMAIN = "sonne2000.IT-Visions.de"
Const WURZEL = "public"
Const ORDNER = "Lehre/Wintersemester2001_2002/VTBDV1"
' --- URL zusammenbauen
url = "http://" & DOMAIN & "/" & WURZEL & "/" & ORDNER
say "Zugriff auf Ordner: " & url
' --- QueryString
Query = "select ""urn:schemas:mailheader:content-class"" "
Query = Query & ",""DAV:href"",""DAV:displayname"" "
Query = Query & " from scope ('shallow traversal of "
Query = Query & Chr(34) & url & Chr(34) & "')"
Query = Query & " ORDER BY ""DAV:displayname"" "
say "Abfrage: " & Query
' --- Menge anfordern
Set rs = get_ExRS(url, Query)
' --- Ausgabe
say "Vorheriger Inhalt:"
list_table rs
say "Lschen aller Nachrichten:"
' --- Alle lschen!
If Not rs.BOF Then rs.MoveFirst
Do Until rs.EOF
    say "Nachricht " & rs("DAV:displayname") & " wird gelscht!"
    rs.Delete
    rs.MoveNext
Loop
' --- Ausgabe
say "Verbliebene Inhalt:"
list_table rs
End Sub

' === Lesen einer Nachricht und Speicherung als Stream
Sub ADOEX2K_NachrichtLesen()
Dim oStrm ' As ADODB.Stream
Dim rec ' as ADODB.Record
Dim url ' As string

' --- Verbindungsaufbau
' Angaben zum Ordner
Const DOMAIN = "sonne2000.IT-Visions.de"
Const WURZEL = "public"
Const ORDNER = "Lehre/Wintersemester2001_2002/VTBDV1/curriculum.eml"
' URL zusammenbauen
url = "http://" & DOMAIN & "/" & WURZEL & "/" & ORDNER
say "Zugriff auf Ordner: " & url
' Instanzzierung der Klasse
Set rec = CreateObject("ADODB.Record")
' ffnen des Record zum Lesen und Schreiben
Const adModeReadWrite = 3
rec.Open url, , adModeReadWrite
say "Nachricht geffnet: " & rec.ActiveConnection

' --- Informationen ber die Nachricht
say "von: " & rec.fields("urn:schemas:mailheader:from")
say "Betreff: " & rec.fields("urn:schemas:mailheader:subject")
say "uam/um: " & rec.fields("DAV:creationdate")

' --- Speichern als Stream
Const adSaveCreateOverWrite = 2
Const adDefaultStream = -1
Set oStrm = rec.fields(adDefaultStream).Value
oStrm.SaveToFile "d:\buch\curriculum.txt", adSaveCreateOverWrite
End Sub
