Attribute VB_Name = "modCDO30"
' ===========================================================
' Beispiele zur Exchange 2000-Programmierung
' (C) Holger Schwichtenberg 2001 (hs@windows-scripting.de)
' ===========================================================
' Diese Beispiele werden in der 3.Auflage des Buchs
' "Windows- und Backoffice-Scripting"
' im Juli 2001 bei Addison-Wesley erscheinen!
' ===========================================================
' Daten der ersten und zweiten Auflage:
' Verlag: Addison-Wesley
' ISBN: 3-8273-1637-5; Preis: 99,90 DM
' Autor: Holger Schwichtenberg, (C) 2000
' ===========================================================
' Weitere Informationen unter http://www.windows-scripting.de
' Aktualisierungen und Bugfixes  werden dort verffentlicht!
' ===========================================================


' ### Hilfsroutine zum Anlegen eines neuen ffentlichen Ordners
Sub CreateFolder(url, ContentClass, Description)
Const adModeReadWrite = 3
Const adCreateCollection = 8192
Const adCreateOverwrite = 67108864
say "Anlegen des Ordners: " & url
Set oF = CreateObject("CDO.Folder")
oF.ContentClass = ContentClass
oF.Description = Description
oF.DataSource.SaveTo url, , adModeReadWrite, adCreateCollection Or adCreateOverwrite
say "Ordner angelegt!"
End Sub

' === Anlegen einer neuen Nachricht
Sub CDO3_neueOrdnerNachricht()
Dim oM  ' As CDO.Message
Const adModeReadWrite = 3
Const adCreateOverwrite = 67108864

' --- Angaben zum Ordner
Const DOMAIN = "sonne2000.IT-Visions.de"
Const WURZEL = "public"
Const ORDNER = "Lehre/rundschreiben/01_2001.eml"
' --- URL zusammenbauen
url = "http://" & DOMAIN & "/" & WURZEL & "/" & ORDNER
say "Anlegen einer neuen Nachricht in: " & url
Set oM = CreateObject("CDO.Message")
oM.Subject = "Rundschreiben 1/2001"
oM.Sender = "hs@it-visions.de"
oM.TextBody = "..."
oM.DataSource.SaveTo url, , adModeReadWrite, adCreateOverwrite
say "Nachricht angelegt!"
End Sub

' === Senden einer eMail mit Exchange2000
Sub CDO3_test_sendmail()
' --- Angaben zum Ordner
Const DOMAIN = "sonne2000.IT-Visions.de"
Const WURZEL = "exchange"
Const POSTFACHNAME = "hs"
' --- URL zusammenbauen
url = "http://" & DOMAIN & "/" & WURZEL & "/" & POSTFACHNAME
' --- Senden einer Nachricht
cdo3_sendmail url, "hs@IT-Visions.de", "hs@IT-Visions.de", "TEST", "TEST"
End Sub

' ### Senden einer eMail mit Exchange2000
Sub cdo3_sendmail(mailbox, von, an, betreff, INHALT)
Dim oConfig ' As CDO.Configuration
Dim oField ' As ADODB.Field
Dim oMsg  ' As CDO.Message
Const cdoSendUsingExchange = 3
Const cdoSendUsingMethod = "http://schemas.microsoft.com/cdo/configuration/sendusing"
Const cdoSendUserName = "http://schemas.microsoft.com/cdo/configuration/sendusername"

' --- Instanzieren der notwendigen Klassen
Set oMsg = CreateObject("CDO.Message")
Set oConfig = CreateObject("CDO.Configuration")
' --- Setzen der Konfigurationsinformationen
say "Senden einer E-Mail von Postfach: " & mailbox
With oConfig.fields
  .Item(cdoSendUsingMethod) = cdoSendUsingExchange
  .Item(cdoMailboxURL) = mailbox
  .Item(cdoSendUserName) = von
  .Update
End With
' --- Setzen der Nachrichteneigenschaften
With oMsg
    ' --- Zuweisen der Konfiguration
    .Configuration = oConfig
    .From = von
    .To = an
    .Subject = betreff
    .TextBody = INHALT
    ' --- Anhngen eines Attachments
    Set iBodyPart = .AddAttachment("d:\buch\docs\test.doc")
    iBodyPart.ContentMediaType = "text/html"
    ' --- Versand
    .Send ' Senden
End With

say "eMail wurde gesendet an " & an
End Sub


' ### Das Skript liefert Informationen ber eine bestimmte Nachricht
Sub CDO3_Nachrichtauswerten()
Dim iDS ' As CDO.IDataSource
Dim iBP ' As CDO.IBodyPart
Dim iMsg ' As CDO.Message
Const adModeReadWrite = 3

' --- Angaben zum Ordner
Const DOMAIN = "sonne2000.IT-Visions.de"
Const WURZEL = "public"
Const ORDNER = "Lehre/Rundschreiben/01_2001.eml"
' --- URL zusammenbauen
url = "http://" & DOMAIN & "/" & WURZEL & "/" & ORDNER

Set iMsg = CreateObject("CDO.Message")
Set iDS = iMsg.DataSource

' --- Binden an eine Nachricht
iDS.Open url, , adModeReadWrite
' --- Basisinformationen
say "Absender:" & iMsg.Sender
say "Betreff:" & iMsg.Subject
say "Body:" & iMsg.TextBody
' --- Teile des Inhalt
say "-- Bodyparts:"
For Each iBP In iMsg.BodyPart.BodyParts
    list_fields iBP
Next
' --- Anhnge
say "-- Attachments:"
For Each iBP In iMsg.Attachments
    say iBP.FileName
    list_fields iBP
    iBP.SaveToFile "d:\buch\anhaenge\" & iBP.FileName
Next
End Sub

' ### Ausgabe aller Felder eines (Record-)Objekts
Sub list_fields(obj)
Dim oF ' As ADODB.Field
say "Anzahl der Eigenschaften: " & obj.fields.Count
For Each oF In obj.fields
   If IsNull(oF.Value) Then
      say oF.Name & "= NULL"
   Else
      say oF.Name & "=" & flat(oF.Value)
   End If
Next
End Sub

' === Abruf von Daten ber eine Mailempfnbger
Sub CDO30_PersonInfo()
Const LDAP_USER = "LDAP://sonne2000/CN=Steuerberater,OU=Lieferanten,OU=IT-Objects GmbH,DC=IT-Visions,DC=de"
Dim objPerson As CDO.IPerson
Dim objDS As CDO.IDataSource
Set objPerson = CreateObject("CDO.Person")
' ----------------- Alternativen:
' 1. Mglichkeit
objPerson.DataSource.Open LDAP_USER
' 2. Mglichket
Set objDS = objPerson.GetInterface("IDataSource")
objDS.Open LDAP_USER
' -----------------------------
say objPerson.email
End Sub

' === Beispiel fr das Anlegen eines ffentlichen Ordners
Sub CDO3_neuerOrdner()
' --- Angaben zum Ordner
Const DOMAIN = "sonne2000.IT-Visions.de"
Const WURZEL = "public"
Const ORDNER = "Lehre/Rundschreiben"
' --- URL zusammenbauen
url = "http://" & DOMAIN & "/" & WURZEL & "/" & ORDNER
' --- Ordner anlegen
CreateFolder url, "urn:content-classes:contactfolder", "Ordner nur fr Professoren!"
say "Ordner angelegt!"
End Sub

